#version 330 core

in vec3 position;
in vec2 uv;
in vec3 normal;

//instancing
in mat4 modelMatrix;
in mat4 inverseModelMatrix;

uniform mat4 viewProjectionMatrix;
uniform mat4 lightSpaceMapMatrix;

out VS_OUT {
	vec3 FragPos;
	vec3 Normal;
	vec2 TexCoord;
	vec4 FragPosLightSpace;
} vs_out;


void main()
{
	mat4 VPM = viewProjectionMatrix * modelMatrix;
	gl_Position = VPM * vec4(position, 1.0f);
	vs_out.FragPos = vec3(modelMatrix * vec4(position, 1.0f));
	vs_out.Normal = mat3(inverseModelMatrix) * normal;
	vs_out.TexCoord = uv; 
	vs_out.FragPosLightSpace = lightSpaceMapMatrix * vec4(vs_out.FragPos, 1.0f);
}